﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Security.Principal;
using System.Text;

namespace ImpersonationSample
{
    class Program
    {
        static void Main(string[] args)
        {
            string userName, password;

            Console.WriteLine("Impersonation Sample");
            Console.WriteLine("--------------------");
            Console.WriteLine(@"Pour cet exemple, nous allons essayer de créer le fichier E:\Test\File.txt dont le dossier n'est accessible que pour un utilisateur");
            Console.Write("Essai n°1 : ");
            Console.WriteLine(Test());
            Console.WriteLine("Donc on va utiliser l'impersonation pour pouvoir utiliser temporairement \"son compte\" afin de pouvoir créer le fichier");
            Console.Write("Username : ");
            userName = Console.ReadLine();
            Console.Write("Password : ");
            password = Console.ReadLine();
            Console.Write("Essai n°2 : ");

            // On tente avec l'impersonation
            Impersonation impersonation = new Impersonation(string.Empty, userName, password);

            Console.WriteLine(Test());

            // On revient à l'utilisateur "en cours"
            impersonation.Dispose();



            Console.Read();
        }

        static string Test()
        {
            try
            {
                File.Create(@"E:\Test\File.txt");
                return "Fichier crée";
            }
            catch (Exception e)
            {
                return @"/!\ Impossible de créer le fichier";
            }
        }
    }

    public class Impersonation : IDisposable
    {
        [DllImport("advapi32.dll", SetLastError = true)]
        private static extern bool LogonUser(string lpszUsername, string lpszDomain, string lpszPassword, int dwLogonType, int dwLogonProvider, out IntPtr phToken);

        private const int LOGON32_PROVIDER_DEFAULT = 0;
        private const int LOGON32_LOGON_INTERACTIVE = 2;

        private WindowsImpersonationContext _impersonationContext;

        public Impersonation(string domain, string login, string password)
        {
            try
            {
                IntPtr tokenHdle = IntPtr.Zero;

                bool ret = LogonUser(login, domain, password, LOGON32_LOGON_INTERACTIVE, LOGON32_PROVIDER_DEFAULT, out tokenHdle);

                Trace.WriteLine("Current user : " + WindowsIdentity.GetCurrent().Name);

                WindowsIdentity newIdentity = new WindowsIdentity(tokenHdle);
                _impersonationContext = newIdentity.Impersonate();

                Trace.WriteLine("Current user : " + WindowsIdentity.GetCurrent().Name);
            }
            catch (Exception e)
            {
                Console.WriteLine(e.ToString());
            }
        }

        #region IDisposable Membres

        public void Dispose()
        {
             _impersonationContext.Undo();
             Trace.WriteLine("Current user : " + WindowsIdentity.GetCurrent().Name);
        }

        #endregion
    }
}
